Subject: Can Multihop BFD be protected using RLFA backup?

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Thu, 17 Jan 2019 14:46:04 +0530

Hi All,

Multihop BFD (RFC 5883) packets are sent over UDP/IP. The encapsulation
used is identical to single hop BFD (RFC 5881) except that the UDP
destination port is set to 4784.

Now, suppose on the ingress node there is no IP/LFA backup path for the
destination address tracked by multihop BFD, but there exists an an RLFA
backup path to that destination. In this case, is multihop BFD expected to
be protected using the RLFA backup path i.e should multihop BFD packets be
sent over the RLFA backup path if the primary path goes down?

If multihop BFD packets are to be sent over the RLFA backup path, what
encapsulation should the ingress use? The encapsulation specified in RFC
5883 or the encapsulation specified in RFC 5884 (MPLS BFD)?

Please let me know you opinion.

Regards,
Muthu

---

From: <[email-masked]>
Date: Thu, 17 Jan 2019 09:57:13 +0000

Hi,

I think that the fact that “control” packets can benefit of FRR is really implementation dependent. It is also linked to the place where BFD packets are created (RP or LC).
From a theoretical point of view, nothing prevents FRR to be used as for any packet generated by the router itself.
Regarding the encapsulation, if your BFD client is using RFC5883, this will not change during FRR, the FRR will just push labels on top independently.

Again, the possibility to get FRR is really implementation dependent, as the forwarding decision of the BFD packet may not be taken by the network processor of the LC.

Brgds,

From: Rtg-bfd [mailto:[email-masked]] On Behalf Of Muthu Arul Mozhi Perumal
Sent: Thursday, January 17, 2019 10:16
To: [email-masked]
Subject: Can Multihop BFD be protected using RLFA backup?

Hi All,

Multihop BFD (RFC 5883) packets are sent over UDP/IP. The encapsulation used is identical to single hop BFD (RFC 5881) except that the UDP destination port is set to 4784.

Now, suppose on the ingress node there is no IP/LFA backup path for the destination address tracked by multihop BFD, but there exists an an RLFA backup path to that destination. In this case, is multihop BFD expected to be protected using the RLFA backup path i.e should multihop BFD packets be sent over the RLFA backup path if the primary path goes down?

If multihop BFD packets are to be sent over the RLFA backup path, what encapsulation should the ingress use? The encapsulation specified in RFC 5883 or the encapsulation specified in RFC 5884 (MPLS BFD)?

Regards,
Muthu

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.

---

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Thu, 17 Jan 2019 16:32:21 +0530

Hi Stephane,

Thanks for your response. Please see inline..

On Thu, Jan 17, 2019 at 3:27 PM <[email-masked]> wrote:

> Hi,
>
>
>
> I think that the fact that “control” packets can benefit of FRR is really
> implementation dependent. It is also linked to the place where BFD packets
> are created (RP or LC).
>
> From a theoretical point of view, nothing prevents FRR to be used as for
> any packet generated by the router itself.
>

Do we know of any implementation that provides RLFA FRR protection to
multihop BFD packets?

> Regarding the encapsulation, if your BFD client is using RFC5883, this
> will not change during FRR, the FRR will just push labels on top
> independently.
>

The primary reason for my question on encapsulations is because RFC 4379
has the foll. as one of the reasons for using the destination address
in 127/8 range for IPv4 (0:0:0:0:0:FFFF:7F00/104 range for IPv6) for
diagnostic packets sent over MPLS LSP:
   1. Although the LSP in question may be broken in unknown ways, the
      likelihood of a diagnostic packet being delivered to a user of an
      MPLS service MUST be held to an absolute minimum.

Since multihop BFD uses a routable destination address, wondering whether
there would be any issues if multihop BFD packets are sent over the RLFA
backup path without following RFC 5884 encapsulation..

Regards,
Muthu

>
>
> Again, the possibility to get FRR is really implementation dependent, as
> the forwarding decision of the BFD packet may not be taken by the network
> processor of the LC.
>
>
>
> Brgds,
>
>
>
> *From:* Rtg-bfd [mailto:[email-masked]] *On Behalf Of *Muthu
> Arul Mozhi Perumal
> *Sent:* Thursday, January 17, 2019 10:16
> *To:* [email-masked]
> *Subject:* Can Multihop BFD be protected using RLFA backup?
>
>
>
> Hi All,
>
>
>

---

From: Alexander Vainshtein <[email-masked]>
Date: Thu, 17 Jan 2019 12:20:02 +0000

Muthu,
Regarding the question in your 2nd email “Do we know of any implementation that provides RLFA FRR protection to multihop BFD packets?”
My employer (ECI Telecom) has implemented multi-hop IP BFD protected by IP FRR (including local and remote LFA) with encapsulation that follows RFC 5883.
(As explained by Stephane, IP FRR does not differentiate between multi-hop IP BFD and any other native IP traffic to the protected destination).
Multi-hop IP BFD is used for reliable and reasonably fast detection of failure of iBGP peers that, in its turn,  can trigger appropriate protection mechanisms.

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]

From: Rtg-bfd <[email-masked]> On Behalf Of Muthu Arul Mozhi Perumal
Sent: Thursday, January 17, 2019 1:02 PM
To: [email-masked]
Cc: [email-masked]
Subject: Re: Can Multihop BFD be protected using RLFA backup?

Hi Stephane,

On Thu, Jan 17, 2019 at 3:27 PM <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

Do we know of any implementation that provides RLFA FRR protection to multihop BFD packets?

The primary reason for my question on encapsulations is because RFC 4379 has the foll. as one of the reasons for using the destination address in 127/8 range for IPv4 (0:0:0:0:0:FFFF:7F00/104 range for IPv6) for diagnostic packets sent over MPLS LSP:
   1. Although the LSP in question may be broken in unknown ways, the
      likelihood of a diagnostic packet being delivered to a user of an
      MPLS service MUST be held to an absolute minimum.

Since multihop BFD uses a routable destination address, wondering whether there would be any issues if multihop BFD packets are sent over the RLFA backup path without following RFC 5884 encapsulation..

Regards,
Muthu

Brgds,

From: Rtg-bfd [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Muthu Arul Mozhi Perumal
Sent: Thursday, January 17, 2019 10:16
To: [email-masked]<mailto:[email-masked]>
Subject: Can Multihop BFD be protected using RLFA backup?

Hi All,

Regards,
Muthu

Thank you.

___________________________________________________________________________

This e-mail message is intended for the recipient only and contains information which is 
CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this 
transmission in error, please inform us by e-mail, phone or fax, and then delete the original 
and all copies thereof.
___________________________________________________________________________

---

From: Alexander Vainshtein <[email-masked]>
Date: Thu, 17 Jan 2019 12:54:56 +0000

Muthu, and all,
A minor correction: s/iBGP peers/remote BGP Next Hops/ in my previous email.

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302

From: Alexander Vainshtein
Sent: Thursday, January 17, 2019 2:20 PM
To: 'Muthu Arul Mozhi Perumal' <[email-masked]>
Cc: [email-masked]; [email-masked]
Subject: RE: Can Multihop BFD be protected using RLFA backup?

Muthu,

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]<mailto:[email-masked]>

From: Rtg-bfd <[email-masked]<mailto:[email-masked]>> On Behalf Of Muthu Arul Mozhi Perumal
Sent: Thursday, January 17, 2019 1:02 PM
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: Can Multihop BFD be protected using RLFA backup?

Hi Stephane,

Regards,
Muthu

Brgds,

Hi All,

Regards,
Muthu

Thank you.

---

From: Jeff Tantsura <[email-masked]>
Date: Thu, 17 Jan 2019 09:31:07 -0800

Muthu,

Multihop BFD provides liveness monitoring of a remote end point while LFA/rLFA provides protection of a local resource.
Theory:
If Multihop BFD packets happen to exit the system over an interface that is protected by LFA/rLFA, when that interface fails, they should be transparently sent over the protecting path
Practice:
Depending on implementation (as Stephane said) locally generated traffic (which BFD is) could be injected into fast path at different stages and could be the case that the injection point for bfd is done too late to get it into protecting path. In general - “slow BFD” (RP generated) would follow the transit traffic path, ASIC/NPU generated BFD - really depends.

Cheers,
Jeff

---

From: "Nagendra Kumar Nainar (naikumar)" <[email-masked]>
Date: Thu, 17 Jan 2019 21:06:53 +0000

Hi Muthu,

<Nagendra> In end-to-end LSP scenarios, RFC5884 is applicable that suggests to use 127/8 or ::FFFF:7F00/104 address. I am not aware of any IP environment with LSP rLFA. Theoretically I think it wont/shouldn’t change the encapsulation but simply push the rLFA stack.

Regards,
Nagendra

From: Rtg-bfd <[email-masked]> on behalf of Muthu Arul Mozhi Perumal <[email-masked]>
Date: Thursday, January 17, 2019 at 6:02 AM
To: "[email-masked]" <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: Re: Can Multihop BFD be protected using RLFA backup?

Hi Stephane,

Regards,
Muthu

Brgds,

Hi All,

Regards,
Muthu

Thank you.

---

From: <[email-masked]>
Date: Fri, 18 Jan 2019 08:22:09 +0000

Hi,

When you are using multihop BFD RFC5883 you are not monitoring an LSP. When IPFRR is activated, the primary goal of your BFD probe does not change and is still not to monitor an LSP but the remote IP destination. So it makes sense that FRR just pushes it stack without changing anything in the BFD encaps.
In addition, I don’t think that it will be easy from a dataplane point of view to change the BFD encaps on the fly during FRR.

Brgds,

From: Muthu Arul Mozhi Perumal [mailto:[email-masked]]
Sent: Thursday, January 17, 2019 12:02
To: LITKOWSKI Stephane OBS/OINIS
Cc: [email-masked]
Subject: Re: Can Multihop BFD be protected using RLFA backup?

Hi Stephane,

Regards,
Muthu

Brgds,

Hi All,

Regards,
Muthu

Thank you.

---

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Sat, 19 Jan 2019 17:01:46 +0530

Thank you Stephane, Sasha, Jeff and Nagendra, for your feedback!

Regards,
Muthu

On Fri, Jan 18, 2019 at 1:52 PM <[email-masked]> wrote:

> Hi,
>
>
>
> When you are using multihop BFD RFC5883 you are not monitoring an LSP.
> When IPFRR is activated, the primary goal of your BFD probe does not change
> and is still not to monitor an LSP but the remote IP destination. So it
> makes sense that FRR just pushes it stack without changing anything in the
> BFD encaps.
>
> In addition, I don’t think that it will be easy from a dataplane point of
> view to change the BFD encaps on the fly during FRR.
>
>
>
> Brgds,
>
>
>
> *From:* Muthu Arul Mozhi Perumal [mailto:[email-masked]]
> *Sent:* Thursday, January 17, 2019 12:02
> *To:* LITKOWSKI Stephane OBS/OINIS
> *Cc:* [email-masked]
> *Subject:* Re: Can Multihop BFD be protected using RLFA backup?
>
>
>
> Hi Stephane,
>
>
>